> ## Documentation Index
> Fetch the complete documentation index at: https://docs.zapier.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List stored actions

> Stored Actions endpoints handle the creation, execution, updates, and deletions
of single created actions.



## OpenAPI

````yaml /api-reference/specs/actions.yaml get /actions/v1/stored-actions
openapi: 3.1.0
info:
  title: Actions API
  description: >-
    Public access to Zapier Stored Actions and the runs that execute them —
    create, list, retrieve, update, and delete stored actions; trigger runs and
    fetch run results.
  version: v1
  contact:
    url: https://docs.zapier.com
servers:
  - url: https://api.zapier.com
    description: Production
security:
  - OAuth: []
tags:
  - name: Stored Actions
    description: Operations related to a Stored Action
paths:
  /actions/v1/stored-actions:
    get:
      tags:
        - Stored Actions
      summary: List stored actions
      description: >-
        Stored Actions endpoints handle the creation, execution, updates, and
        deletions

        of single created actions.
      operationId: listStoredActions
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/StoredActionRecordListResponse'
              examples:
                Success:
                  value:
                    results:
                      - type: stored_action
                        id: 01932123-02ea-01fc-3fbd-4d66d944064d
                        connection_id: 019320ab-0000-7000-8000-abcdef012345
                        selected_api: SplitwiseCLIAPI@1.0.0
                        action_key: new_contact
                        action_type: read
                        inputs:
                          first_name: John
                          last_name: Doe
                    meta:
                      limit: 1
                      offset: 0
                      count: 1
                    links:
                      next: null
          description: >-
            Success: Includes all the Stored Actions for the caller. This could
            be an empty list.
          headers:
            X-RateLimit-Limit:
              schema:
                type: integer
              description: >-
                Effective request cap per 300-second window. Default: 200.
                Maximum via limit_override: 1000.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: Requests remaining in the current window.
            X-RateLimit-Reset:
              schema:
                type: string
                format: date-time
              description: Unix timestamp when the current 300-second window resets.
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ActionsErrorResponse'
              examples:
                BadRequest:
                  value:
                    errors:
                      - status: 400
                        code: bad_request
                        title: Bad Request
                        detail: Improperly formatted or incompleted request
                        source: null
                        meta: {}
                  summary: Bad Request
          description: Indicates an error executing the request to list Stored Actions.
          headers:
            X-RateLimit-Limit:
              schema:
                type: integer
              description: >-
                Effective request cap per 300-second window. Default: 200.
                Maximum via limit_override: 1000.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: Requests remaining in the current window.
            X-RateLimit-Reset:
              schema:
                type: string
                format: date-time
              description: Unix timestamp when the current 300-second window resets.
        '403':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ActionsErrorResponse'
              examples:
                PermissionDenied:
                  value:
                    errors:
                      - status: 403
                        code: permission_denied
                        detail: >-
                          User does not have enough permissions to perform
                          action
                  summary: Permission Denied
          description: Permission denied. Unauthorized request.
        '429':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ActionsErrorResponse'
              examples:
                TooManyRequests:
                  value:
                    errors:
                      - status: 429
                        code: too_many_requests
                        detail: Rate limit exceeded. Too many requests.
                  summary: Too Many Requests
          description: Too many requests.
          headers:
            X-RateLimit-Limit:
              schema:
                type: integer
              description: >-
                Effective request cap per 300-second window. Default: 200.
                Maximum via limit_override: 1000.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: Requests remaining in the current window.
            X-RateLimit-Reset:
              schema:
                type: string
                format: date-time
              description: Unix timestamp when the current 300-second window resets.
            Retry-After:
              schema:
                type: integer
              description: Seconds to wait before retrying.
              required: true
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ActionsErrorResponse'
              examples:
                UnhandledOrExternalServiceError:
                  value:
                    errors:
                      - status: 500
                        code: external_service_error
                        detail: An error occurred with an external service.
                  summary: Unhandled or External Service Error
          description: Internal Server Error
          headers:
            X-RateLimit-Limit:
              schema:
                type: integer
              description: >-
                Effective request cap per 300-second window. Default: 200.
                Maximum via limit_override: 1000.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: Requests remaining in the current window.
            X-RateLimit-Reset:
              schema:
                type: string
                format: date-time
              description: Unix timestamp when the current 300-second window resets.
        '503':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ActionsErrorResponse'
              examples:
                ServiceUnavailableError:
                  value:
                    errors:
                      - status: 503
                        code: service_unavaiable
                        detail: Service is temporarily unavailable
                  summary: Service Unavailable Error
          description: Service Unavailable
          headers:
            X-RateLimit-Limit:
              schema:
                type: integer
              description: >-
                Effective request cap per 300-second window. Default: 200.
                Maximum via limit_override: 1000.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: Requests remaining in the current window.
            X-RateLimit-Reset:
              schema:
                type: string
                format: date-time
              description: Unix timestamp when the current 300-second window resets.
            Retry-After:
              schema:
                type: integer
              description: Seconds to wait before retrying.
              required: true
      security:
        - OAuth:
            - external
components:
  schemas:
    StoredActionRecordListResponse:
      type: object
      properties:
        results:
          type: array
          items:
            $ref: '#/components/schemas/StoredActionRecord'
          description: Stored actions belonging to the caller.
        meta:
          $ref: '#/components/schemas/StoredActionRecordListMeta'
        links:
          $ref: '#/components/schemas/StoredActionRecordListLinks'
      required:
        - links
        - meta
        - results
    ActionsErrorResponse:
      type: object
      properties:
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ActionsError'
          description: An array of error objects.
      required:
        - errors
    StoredActionRecord:
      type: object
      description: The shape of a payload representing a stored action record.
      properties:
        connection_id:
          type: string
          format: uuid
          description: >-
            UUID identifying the connection to use when executing a Stored
            Action.
        selected_api:
          type: string
          description: >-
            Something like `SlackAPI` (for Python apps) or
            `SplitwiseCLIAPI@1.0.0` (for CLI apps). Non-public apps are fine as
            long as the authed user can access them. If a version is included we
            attempt to use that version of the integration.  If no version is
            provided we attempt to use the latest version of the integration
        action_key:
          type: string
          description: Name of the action in the integration. Such as `new_contact`.
        action_type:
          allOf:
            - $ref: '#/components/schemas/ActionTypeEnum'
          description: >-
            Specifies the type of action in the integration since some
            integrations could have similarly named actions with different
            actions types


            * `read` - Read

            * `read_bulk` - Read Bulk

            * `write` - Write

            * `run` - Run

            * `search` - Search

            * `search_or_write` - Search Or Write

            * `search_and_write` - Search And Write

            * `filter` - Filter
        inputs:
          default: {}
          description: >-
            Key/value pairs that the action needs to execute. In the example of
            SlackAPI this could be something like `{"channel": "ABC", "text":
            "my message"}`
        id:
          type: string
          format: uuid
          description: >-
            The UUID id that identifies this stored action and can be used to
            execute the stored procedure by calling the POST
            /stored-actions/{stored_action_id}/run endpoint.
        type:
          type: string
          default: stored_action
          description: >-
            Specifies the resource type, as required by the JSON:API
            specification.
      required:
        - id
    StoredActionRecordListMeta:
      type: object
      description: Limit-offset pagination metadata for a Stored Action list response.
      properties:
        limit:
          type: integer
          description: Number of results returned in this response.
        offset:
          type: integer
          description: Starting index for this page of results.
        count:
          type: integer
          description: Total number of results across all pages.
      required:
        - count
        - limit
        - offset
    StoredActionRecordListLinks:
      type: object
      description: Pagination navigation links for a Stored Action list response.
      properties:
        next:
          type:
            - string
            - 'null'
          format: uri
          description: Link to the next page of results; null when on the last page.
      required:
        - next
    ActionsError:
      type: object
      description: Base Error definition
      properties:
        status:
          type: integer
          description: The HTTP status code applicable to this problem.
        code:
          type: string
          description: A unique identifier for this particular occurrence of the problem.
        title:
          type: string
          description: A short summary of the problem.
        detail:
          type: string
          description: >-
            A human-readable explanation specific to this occurrence of the
            problem.
        source:
          oneOf:
            - $ref: '#/components/schemas/ActionsErrorSource'
            - type: 'null'
          description: An object containing references to the primary source of the error.
        meta:
          type:
            - object
            - 'null'
          additionalProperties: {}
          description: Any additional metadata about the error.
    ActionTypeEnum:
      enum:
        - read
        - read_bulk
        - write
        - run
        - search
        - search_or_write
        - search_and_write
        - filter
      type: string
      description: |-
        * `read` - Read
        * `read_bulk` - Read Bulk
        * `write` - Write
        * `run` - Run
        * `search` - Search
        * `search_or_write` - Search Or Write
        * `search_and_write` - Search And Write
        * `filter` - Filter
    ActionsErrorSource:
      type: object
      description: Populates the `source` object inside our error responses.
      properties:
        pointer:
          type: string
          description: >-
            Pointer to the value in the request document that caused the error
            e.g. `/actions`.
        parameter:
          type: string
          description: A string indicating which URI query parameter caused the error.
        header:
          type: string
          description: >-
            A string indicating the name of a single request header which caused
            the error.
  securitySchemes:
    OAuth:
      type: oauth2
      description: OAuth 2.0 authentication.
      flows:
        authorizationCode:
          authorizationUrl: https://zapier.com/oauth/authorize
          tokenUrl: https://zapier.com/oauth/token
          scopes:
            external: Scope that gives access to all Public APIs
        clientCredentials:
          tokenUrl: https://zapier.com/oauth/token
          scopes:
            external: Scope that gives access to all Public APIs

````